'use strict'

const path = require('path')

const Assets = require('./assets')

module.exports = () => ({
  fromFilepath: (filepath) => {
    const filename = path.basename(filepath)
    let trait, value, rarity
    try {
      const match = /(.*)-(.*)-(.*)\.(.*)/.exec(filename)
      trait = match[1]
      value = match[2]
      rarity = match[3]
    } catch (e) {
      console.log(`Il file ${filepath} fa cagare`)
      throw e
    }

    if (!trait) {
      throw new Error(`Filename must contain trait info, ${filepath} received`)
    }

    if (!value) {
      throw new Error(`Filename must contain value info, ${filepath} received`)
    }

    const rarities = rarity.split('_') || []
    if (!rarity || rarities.length === 0) {
      throw new Error(`Filename must contain rarity info, ${filepath} received`)
    }

    return new Assets(trait, rarities, value, filepath)
  },
})
