'use strict'

module.exports = () => {
  const items = new Map()
  const traitMap = new Map()
  return {
    getTraitMap: () => traitMap,

    has: (combination) => items.has(combination.id()),
    add: (combination) => {
      items.set(combination.id(), combination)
    },

    get: (combination) => items.get(combination.id()),

    count: () => items.size,
    items: () => Array.from(items.values()),

    getAssets: function (combination) {
      const traits = this.get(combination).traits()

      return traits.map((id) => {
        const [trait] = id.split(':')

        return traitMap.get(trait).getAsset(id)
      })
    },
  }
}
