'use strict'

module.exports = class Trait {
  constructor(name) {
    this.name = name
    this.assets = new Map()
    this.rarities = new Map()
  }

  addElement(asset) {
    this.assets.set(asset.id, asset)
    for (const rarity of asset.rarities) {
      if (!this.rarities.has(rarity)) {
        this.rarities.set(rarity, [])
      }
      this.rarities.get(rarity).push(asset.id)
    }

    return this
  }

  getAsset(id) {
    return this.assets.get(id)
  }

  getAssetsByRarity(rarity) {
    return this.rarities.get(rarity)
  }

  size() {
    return this.assets.size
  }
}
